<template>
	<div>
		<div class="cards">
			<h4>Registrierte Benutzer</h4>
			<div class="card-body">
				<div class="cols c-0-1-0-0-0 b-gap-1">
					<div class="cell c-merged-2">
						<custom-switch @clicked="globalToggleDeleteButtons" />
						L&ouml;schen
					</div>
					<div class="cell">ID</div>
					<div class="cell">E</div>
					<div class="cell">K</div>
					<template v-for="user in usersPaginated">
						<div :key="'col1' + user.id" class="cell">
							<button ref="delete" @click="deleteUser(user.id)" class="button button--close" disabled></button>
						</div>
						<div :key="'col2' + user.id" class="cell bg-4">{{ user.name }}</div>
						<div :key="'col3' + user.id" class="cell text-center bg-4">{{ user.id }}</div>
						<div :key="'col4' + user.id" class="cell text-center" :class="[ user.totalAttendedEvents ? 'bg-4' : 'bg-t1' ]">{{ user.totalAttendedEvents }}</div>
						<div :key="'col5' + user.id" class="cell text-center" :class="[ user.totalCommentsOnEvents ? 'bg-4' : 'bg-t1' ]">{{ user.totalCommentsOnEvents }}</div>
					</template>
				</div>

				<paginator @clicked="fetchUsersPaginated" :limiter="2" :total-pages="totalPages" :current-page="currentPage" />

			</div>
			<div class="cell">
				E: besuchte Events, K: Kommentare verfasst
			</div>
		</div>

		<loader v-if="isLoading" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />

	</div>
</template>

<script>
import CustomSwitch from "@/components/buttons/CustomSwitch";
import SystemMessage from "@/components/SystemMessage";
import Loader from "@/components/Loader";
import Paginator from "@/components/Paginator";

export default {
	name: "AdminUsers",
	components: {
		Paginator,
		Loader,
		CustomSwitch,
		SystemMessage
	},
	data: () => ({
		isLoading: false,
		usersPaginated: {},
		totalPages: 0,
		currentPage: 1,
		sysMsg: undefined
	}),
	methods: {
		async fetchUsersPaginated(page = 1) {
			this.isLoading = true;
			const response = await this.$http.get("/api/admin/users/list/" + page);
			this.currentPage = page;
			this.totalPages = response.data.totalPages;
			this.usersPaginated = response.data.paginatedContent;
			this.isLoading = false;
		},

		async deleteUser(id) {
			this.sysMsg = "";
			try {
				const response = await this.$http.delete("/api/admin/users/delete/" + id);
				switch (response.status) {
					case 200:
						this.sysMsg = "User erfolgreich gelöscht!";
						await this.fetchUsersPaginated();
						break;
				}

			} catch (e) {
				console.error(e);
			}
		}
	},

	computed: {
/*
		allUsers() {
			return this.$store.getters.getAllUsers;
		}
*/
	},

	mounted() {
/*
		this.isLoading = true;
		this.$store.dispatch("getAllUsers").then(() => this.isLoading = false);
*/
		this.fetchUsersPaginated();
	}
}
</script>

<style scoped>

</style>